# $Revision: 1.12 $, $Date: 2004/02/20 20:33:08 $
#
# Conditional build:
%bcond_without	pgsql		# without PostgreSQL support
%bcond_without	home_etc	# don't use home_etc
Summary:	GNU GLOBAL - Common source code tag system
Summary(pl):	GNU GLOBAL - system list odwoa powszechnego uytku
Name:		global
Version:	4.6.1
Release:	1
License:	GPL
Group:		Development/Tools
Source0:	ftp://ftp.gnu.org/gnu/%{name}/%{name}-%{version}.tar.gz
# Source0-md5:	6430ca736a74a734b10201d28fe0a64a
Patch10:	%{name}-acinclude-fix.patch
Patch20:	%{name}-ac-shared-pgsql.patch
Patch30:	%{name}-home_etc.patch
Patch40:	%{name}-globash-altercfg.patch
URL:		http://www.gnu.org/software/global/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	texinfo
%{?with_pgsql:BuildRequires:	postgresql-devel}
%{?with_home_etc:BuildRequires:	home-etc-devel}
BuildRequires:	xemacs
Requires:	coreutils
Requires:	findutils
Requires:	id-utils
Provides:	gtags-%{version}-%{release}
Provides:	htags-%{version}-%{release}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
GNU GLOBAL is a source code tag system that works the same way across
diverse environments. It supports C, C++, Yacc, Java, PHP and
assembler source code. You can locate the specified function or method
in source files and move there easily. It is useful to hack a large
project containing many subdirectories, many general, main()-type
functions. It allows you to create one tags container for a big code
tree.
%if %{with pgsql}
Tagging information may be keept in the traditional db files, or shared
using the PostgreSQL database.
%endif
You can also find some subpackages, containing support for additional
GLOBAL's features, and for compliance with common code editors
(symbols' completion, jumping).

%description -l pl
GNU GLOBAL jest powszechnym systemem generowania list odwoa dla
kodw rdowych napisanych w C, C++, Yacc, Java, PHP i asemblerze.
Moesz z jego pomoc odszuka podan funkcj lub metod w plikach
rdowych i w atwy sposb si do niej przenie. Narzdzie to jest
przydatne do dubania w duych projektach, zawierajcych mnstwo
podkatalogw, wiele funkcji gwnych w stylu main(). Pozwala Ci on
utworzy jeden kontener ze znacznikami dla duego drzewa kodu.
%if %{with pgsql}
Informacje o znacznikach mog by przechowywane w postaci plikw db,
lub te wspdzielone przy pomocy bazy danych PostgreSQL.
%endif
Moesz take znale kilka podpakietw, ktre zawieraj wsparcie
dla dodatkowych mechanizmw GLOBAL, a take pozwalaj na wspprac
ze niektrymi znanymi edytorami kodu (dopenianie nazw symboli, przeskakiwanie).

%package htags
Summary:	GNU GLOBAL - programs for making hypertext from source code
Summary(pl):	GNU GLOBAL - programy produkujce hypertext z kodw rdowych
Group:		Development/Tools
Requires:	%{name} = %{version}-%{release}
Requires:	perl-base >= 5.005
Provides:	gozilla-%{version}-%{release}
Provides:	htags-%{version}-%{release}

%description htags
GNU GLOBAL is a source code tag system that works the same way across
diverse environments. It supports C, C++, Yacc, Java, PHP and
assembler source code.

Htags makes hypertext from source code. The package also contains the
gozilla wrapper, which enforces Mozilla-based web browsers to display
source code in an elegant way. Htags can also work with a CVS
repository, which makes it more easy to navigate though the code over
the Web.

%description htags -l pl
GNU GLOBAL jest powszechnym systemem generowania list odwoa dla
kodw rdowych napisanych w C, C++, Yacc, Java, PHP i asemblerze.

Htags jest narzdziem generujcym hypertext z kodw. Pakiet ten
zawiera take program wyskakujcy o nazwie gozilla, ktry zmusza
przegldarki bazujce na Mozilla, aby wywietlay kod rdowy w
elegancki sposb. Htags potrafi rwnie wsppracowa z repozytorium
CVS uatwiajc nawigacj w kodach poprzez WWW.

%package gtags-perl-wrapper
Summary:	GNU GLOBAL - gtags wrapper for tools which use Perl
Summary(pl):	GNU GLOBAL - program pomocniczy dla narzdzi uywajcych Perl
Group:		Development/Tools
Requires:	%{name} = %{version}-%{release}
Requires:	perl-base >= 5.005
Provides:	gtags-perl-wrapper-%{version}-%{release}

%description gtags-perl-wrapper
GNU GLOBAL is a source code tag system that works the same way across
diverse environments. It supports C, C++, Yacc, Java, PHP and
assembler source code.

This package contains simple Perl wrapper, which allows to use the
system for some tools and editors.

%description gtags-perl-wrapper -l pl
GNU GLOBAL jest powszechnym systemem generowania list odwoa dla
kodw rdowych napisanych w C, C++, Yacc, Java, PHP i asemblerze.

Ten pakiet zawiera program pomocniczy, ktry pozwala uywa tego
systemu niektrym narzdziom i edytorom.

%package globash
Summary:	GNU GLOBAL - Bash customization to walk though the source trees
Summary(pl):	GNU GLOBAL - usprawnienie dla Bash do poruszania si po drzewach rde
Group:		Development/Tools
Requires:	%{name} = %{version}-%{release}
Requires:	bash >= 2.05
Provides:	globash-%{version}-%{release}

%description globash
GNU GLOBAL is a source code tag system that works the same way across
diverse environments. It supports C, C++, Yacc, Java, PHP and
assembler source code.

This package allows you to invoke a customized Bash with features that
makes easy to navigate in the sources trees. These are: Vi-like tag
stack, Emacs-like tag name completion, editor or viewer automatic
invocation, tag mark facility, and a cookie facility for managing
directories.

%description globash -l pl
GNU GLOBAL jest powszechnym systemem generowania list odwoa dla
kodw rdowych napisanych w C, C++, Yacc, Java, PHP i asemblerze.

Ten pakiet pozwala wywoywa odpowiednio przystosowan wersj powoki
Bash z udogodnieniami, ktre czyni nawigowanie po drzewku rde
rzecz atw. Do tych udogodnie nale: stos znacznikw w stylu Vi,
dopenianie nazw w styly edytora Emacs, automatyczne wywoywanie
edytorw lub przegldarek, mechanizm wyrniania znacznikw, oraz
mechanizm ciasteczek pomagajcy zarzdza katalogami.

%package -n xemacs-gtags-mode-pkg
Summary:	XEmacs mode for the GNU GLOBAL source tag system
Summary(pl):	Tryb systemu list odwoa GNU GLOBAL dla edytora XEmacs
Group:		Development/Tools
Requires:	%{name} = %{version}-%{release}
Requires:	xemacs

%description -n xemacs-gtags-mode-pkg
GNU GLOBAL is a source code tag system that works the same way across
diverse environments. It supports C, C++, Yacc, Java, PHP and
assembler source code.

This package allows to integrate the GLOBAL source tag system with the
XEmacs editor.

%description -n xemacs-gtags-mode-pkg -l pl
GNU GLOBAL jest powszechnym systemem generowania list odwoa dla
kodw rdowych napisanych w C, C++, Yacc, Java, PHP i asemblerze.

Ten pakiet pozwala zintegrowa system GLOBAL z edytorem XEmacs.

%package -n less-global-tags
Summary:	less pager's helper for GNU GLOBAL source tag system
Summary(pl):	wsparcie dla polecenia less do systemu odwoa GNU GLOBAL
Group:		Development/Tools
Requires:	%{name} = %{version}-%{release}
Requires:	xemacs

%description -n less-global-tags
GNU GLOBAL is a source code tag system that works the same way across
diverse environments. It supports C, C++, Yacc, Java, PHP and
assembler source code.

This package allows users to navigate through GLOBAL tags and
references system using less pager.

%description -n less-global-tags -l pl
GNU GLOBAL jest powszechnym systemem generowania list odwoa dla
kodw rdowych napisanych w C, C++, Yacc, Java, PHP i asemblerze.

Ten pakiet pozwala uytkownikom na nawigacj poprzez system znacznikw
i odwoa systemu GLOBAL uywajc polecenia less.

%prep
%setup -q
%patch10 -p1
%patch20 -p1
%{?with_home_etc:%patch30 -p1}
%patch40 -p1

%build
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
%configure \
	%{?with_pgsql:--with-postgres=shared} \
	%{?with_home_etc:--with-home-etc=shared}
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_bindir} \
	$RPM_BUILD_ROOT%{_sysconfdir}/gtags \
	$RPM_BUILD_ROOT%{_mandir}/man1 \
	$RPM_BUILD_ROOT%{_datadir}/xemacs-packages/lisp/gtags \
	$RPM_BUILD_ROOT/etc/profile.d

# perl wrapper
cp gtags.pl $RPM_BUILD_ROOT%{_bindir}

# globash
cp globash.rc $RPM_BUILD_ROOT%{_sysconfdir}/gtags

# default config
cp gtags.conf $RPM_BUILD_ROOT%{_sysconfdir}/gtags

# emacs support
cp gtags.el $RPM_BUILD_ROOT%{_datadir}/xemacs-packages/lisp/gtags
xemacs -batch -no-autoloads -l autoload -f batch-update-directory \
	$RPM_BUILD_ROOT%{_datadir}/xemacs-packages/lisp/gtags
xemacs -batch -vanilla -f batch-byte-compile \
	$RPM_BUILD_ROOT%{_datadir}/xemacs-packages/lisp/gtags/gtags.el
find $RPM_BUILD_ROOT%{_datadir} -type f -name "*.el" | while read i; do test ! -f ${i}c || rm -f $i; done

# /etc/profile.d/*.sh hook for globash
cat  << EOF > $RPM_BUILD_ROOT/etc/profile.d/globash.sh
alias globash='%{?with_home_etc:GLOBASH_HOME="\$HOME_ETC" }/bin/bash --rcfile %{_sysconfdir}/gtags/globash.rc'
EOF

# /etc/profile.d/*.csh hook for globash
cat  << EOF > $RPM_BUILD_ROOT/etc/profile.d/globash.csh
alias globash '%{?with_home_etc:setenv GLOBASH_HOME = "\$HOME_ETC" ; }/bin/bash --rcfile %{_sysconfdir}/gtags/globash.rc'
EOF

# /etc/profile.d/*sh hooks for less-global
echo 'LESSGLOBALTAGS="global"'	     > $RPM_BUILD_ROOT/etc/profile.d/less-global.sh
echo 'export LESSGLOBALTAGS'	    >> $RPM_BUILD_ROOT/etc/profile.d/less-global.sh
echo 'setenv LESSGLOBALTAGS global'  > $RPM_BUILD_ROOT/etc/profile.d/less-global.csh

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog FAQ LICENSE NEWS README THANKS
%attr(755,root,root) %{_bindir}/g*tags
%attr(755,root,root) %{_bindir}/global
%dir %{_sysconfdir}/gtags
%config(noreplace,missingok) %verify(not md5 size mtime) %{_sysconfdir}/gtags/gtags.conf
%{_mandir}/man1/global*
%{_mandir}/man1/g*tags*
%{_infodir}/*.info*

%files htags
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/htags
%attr(755,root,root) %{_bindir}/gozilla
%{_mandir}/man1/htags*
%{_mandir}/man1/gozilla*

%files gtags-perl-wrapper
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/gtags.pl

%files globash
%defattr(644,root,root,755)
%attr(755,root,root) %config /etc/profile.d/globash*
%config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/gtags/globash.rc

%files -n xemacs-gtags-mode-pkg
%defattr(644,root,root,755)
%dir %{_datadir}/xemacs-packages/lisp/*
%{_datadir}/xemacs-packages/lisp/*/*.el*

%files -n less-global-tags
%defattr(644,root,root,755)
%attr(755,root,root) %config /etc/profile.d/less-global*

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: global.spec,v $
Revision 1.12  2004/02/20 20:33:08  siefca
- less-global-tags subpackage created
- spec adapterized

Revision 1.11  2004/02/20 16:01:36  siefca
- Requires: id-utils

Revision 1.10  2004/02/20 15:49:37  siefca
- BuildRequires: texinfo

Revision 1.9  2004/02/20 15:47:53  siefca
- URL more macrobiotic

Revision 1.8  2004/02/20 15:43:47  siefca
- version 4.6.1
- patches adapterized

Revision 1.7  2004/02/20 13:38:37  siefca
- sexy profile.d hooks for globash

Revision 1.6  2004/02/20 13:03:59  siefca
- native home_etc support for gtags
- pgsql and home_etc patches fixed to allow =shared to configure
- release 4

Revision 1.5  2004/02/20 11:11:45  qboosh
- cleanups/unifications

Revision 1.4  2004/02/20 01:00:36  siefca
- /etc/profile.d/globash* scripts conditioned against bcond: with_home_etc

Revision 1.3  2004/02/20 00:58:08  siefca
- patched globash.rc to allow pass alternate directory for configuration
- fixed /etc/profile.d/globash* scripts and added GLOBASH_HOME exports
- release 3

Revision 1.2  2004/02/20 00:17:04  siefca
- fixed home-etc hook names (now: /etc/profile.d/home-etc_hook-*)
- globash no longer binary, instead it's aliased in profile.d
- release 2

Revision 1.1  2004/02/19 23:30:44  siefca
- initial revision
- added ac-acinclude and ac-pgsql fixes
- added home-etc support
- subpackages created for bash, perl, emacs, HTML-ization and mozilla
